﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Event: Clicked (Pos as int, ID As String)
#Event: Add

'#DesignerProperty: Key: BooleanExample, DisplayName: Show Seconds, FieldType: Boolean, DefaultValue: True
'#DesignerProperty: Key: TextColor, DisplayName: Text Color, FieldType: Color, DefaultValue: 0xFFFFFFFF, Description: Text color

Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Public mBase As B4XView
	Private xui As XUI 'ignore
	Public Tag As Object
	
	Type Gritem_Type (ID As String, it As Int, Image As B4XBitmap, FileImage As String, Codice As String, Name As String, Description As String, Info As String)
	Public Animated As Boolean = True
	Private AnimationActive As Boolean
	Private yy As Double
	Private ListOfItem, ListFilterItem As List
	Private PositionY As Double = -1
	Private isListGrid As Boolean = False
	Private ListInMovement As Boolean = False
	Private nImage As Int = 0
	Private ColsImages As Int = 0
	Private HeightImage As Int = 100dip
	Private HeightGridImage As Int = 150dip
	Private TheImageView() As B4XView
	
	Private ButtonGrid, ButtonList,ButtonAdd, ButtonExit As B4XView
	' List
	Private FilterLabel, FilterText As B4XView
	Private PaneListMenu As B4XView
	Private PanelList,PanelScroll As B4XView
	Private ScrollList As xSD_Scroll
	' Grid
	Private PanelGridMenu As B4XView
	Private GridScroll As xSD_Scroll
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
	
	ListOfItem.Initialize
	ListFilterItem.Initialize
	AnimationActive=False
End Sub

Public Sub AddToParent(MainPane As B4XView,Left As Int, Top As Int,Width As Int, Height As Int)
	mBase=xui.CreatePanel("mBase")
	
	MainPane.AddView(mBase,Left,Top,Width,Height)
	mBase.Color=xui.Color_Transparent

	DesignerCreateView(mBase,Null,Null)
End Sub

'Base type must be Object
Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	mBase = Base
	Tag = mBase.Tag
	mBase.Tag = Me
	'Dim clr As Int = xui.PaintOrColorToColor(Props.Get("TextColor")) 'Example of getting a color value from Props
	
	ButtonGrid=CreateButton("ButtonEvent")
	ButtonGrid.Tag=0
	ButtonGrid.Font=xui.CreateFontAwesome(16)
	ButtonGrid.SetColorAndBorder(0xFF5B9BF2,0dip,xui.Color_Transparent,10dip)
	ChangeButtonTextColor(ButtonGrid,xui.Color_White)
	ButtonGrid.Text=Chr(0xF009)
	ButtonList=CreateButton("ButtonEvent")
	ButtonList.Tag=1
	ButtonList.Font=xui.CreateFontAwesome(16)
	ButtonList.SetColorAndBorder(0xFF5B9BF2,0dip,xui.Color_Transparent,10dip)
	ChangeButtonTextColor(ButtonList,xui.Color_White)
	ButtonList.Text=Chr(0xF00B)
	
	ButtonAdd=CreateButton("ButtonEvent")
	ButtonAdd.Tag=2
	ButtonAdd.Font=xui.CreateFontAwesome(16)
	ButtonAdd.SetColorAndBorder(0xFF47518F,0dip,xui.Color_Transparent,10dip)
	ChangeButtonTextColor(ButtonAdd,xui.Color_White)
	ButtonAdd.Text=Chr(0xF067)
	
	ButtonExit=CreateButton("ButtonEvent")
	ButtonExit.Tag=3
	ButtonExit.Font=xui.CreateFontAwesome(16)
	ButtonExit.SetColorAndBorder(0xFFEC3839,0dip,xui.Color_Transparent,10dip)
	ChangeButtonTextColor(ButtonExit,xui.Color_White)
	ButtonExit.Text=Chr(0xF08B)
	
	FilterLabel=CreateLabel("Filter",xui.Color_White,16)
	FilterLabel.SetTextAlignment("CENTER","CENTER")
	FilterLabel.SetColorAndBorder(0xFF47518F,0dip,xui.Color_Transparent,10dip)
	
	FilterText=CreateTextView("FilterText")
	FilterText.EditTextHint="Filter"
	'FilterText.Color=xui.Color_RGB(240,245,251) '0xFF5B9BF2
	FilterText.SetColorAndBorder(xui.Color_RGB(240,245,251),1dip,0xFF5B9BF2,10dip)
	FilterText.TextColor=0xFF47518F

	mBase.AddView(ButtonGrid,5dip,5dip,50dip,50dip)
	mBase.AddView(ButtonList,60dip,5dip,50dip,50dip)
	mBase.AddView(ButtonAdd,120dip,5dip,50dip,50dip)
	mBase.AddView(ButtonExit,mBase.Width-60dip,5dip,50dip,50dip)
	mBase.AddView(FilterLabel,5dip,70dip,HeightImage,40dip)
	mBase.AddView(FilterText,HeightImage+10dip,70dip,mBase.Width-HeightImage-20dip,40dip)
	
	mBase.Color=xui.Color_White ' xui.Color_ARGB(255,	192, 192, 192)
	
	' List View Create and Initialize
	PaneListMenu=xui.CreatePanel("PaneListMenu")
	PanelScroll = xui.CreatePanel("")
	ScrollList.Initialize(Me,"ScrollList")
	PanelList = xui.CreatePanel("")
	ScrollList.HorizontalBar=False
	' Grid View Crate e Initialize
	PanelGridMenu=xui.CreatePanel("PanelGridMenu")
	GridScroll.Initialize(Me,"GridScroll")
	' End
	#IF B4A
		Sleep(0)
	#END IF
	
	Base_Resize (mBase.Width, mBase.Height)
End Sub

Public Sub Base_Resize (Width As Double, Height As Double)
	mBase.Width=Width
	mBase.Height=Height
	
	If PanelList.IsInitialized Then
		ButtonExit.Left=Width-60dip
		FilterText.Width=Width-HeightImage-20dip
		PaneListMenu.RemoveViewFromParent
		PanelGridMenu.RemoveViewFromParent
		If isListGrid=False Then
			'   ----------------------------    List Mode
			Dim ActualImages As Int = (mBase.Height-130dip)/HeightImage
		
			' Main Panel
			mBase.AddView(PaneListMenu,0,120dip,mBase.Width,mBase.Height-130dip)
	
			' Lista Articolo
			PanelScroll.RemoveViewFromParent
			PaneListMenu.AddView(PanelScroll,HeightImage+10dip,0dip,PaneListMenu.Width-HeightImage-20dip,ActualImages*HeightImage)
			PanelScroll.SetColorAndBorder(xui.Color_RGB(240,245,251),0dip,xui.Color_White,15dip)
	
			ScrollList.RemoveViewFromParent
			ScrollList.AddToParent(PanelScroll,10dip,0dip,PanelScroll.Width-20dip,ActualImages*HeightImage)
			ScrollList.VerticalBar=xui.IsB4J
	
			'Lista Immagini
			PanelList.RemoveViewFromParent
			PaneListMenu.AddView(PanelList,5dip,0,HeightImage,ActualImages*HeightImage)
			PanelList.SetColorAndBorder(0xFF47518F,0dip,xui.Color_White,15dip)
	
			If nImage<>ActualImages Or TheImageView.Length<>nImage Then
				Dim im(ActualImages) As B4XView
				TheImageView=im
				PanelList.RemoveAllViews
			End If
			
			nImage=ActualImages
			For i = 1 To nImage
				TheImageView(i-1)=ImageView("")
				'TheImageView(i-1).SetBitmap(xui.LoadBitmap(File.DirAssets,"wait.png").Resize(HeightImage,HeightImage,False))
				TheImageView(i-1).Color=xui.Color_Transparent
				PanelList.AddView(TheImageView(i-1),10dip,((i-1)*HeightImage)+10dip,HeightImage-20dip,HeightImage-20dip)
			Next
		Else
			' -------------------------------  Grid Mode
			mBase.AddView(PanelGridMenu,10dip,120dip,mBase.Width-20dip,mBase.Height-130dip)
			PanelGridMenu.SetColorAndBorder(xui.Color_RGB(240,245,251),1dip,0xFF5B9BF2,10dip)
			
			' Main Panel
			GridScroll.RemoveViewFromParent
			GridScroll.AddToParent(PanelGridMenu,5dip,5dip,PanelGridMenu.Width-10dip,PanelGridMenu.Height-10dip)
		End If
		Invalidate
	End If
End Sub

#Region Method extra

Public Sub TurnToGrid
	ListInMovement=False
	Sleep(300)
	isListGrid=False
	Base_Resize(mBase.Width,mBase.Height)
	Invalidate
End Sub

Public Sub TurnToList
	isListGrid=True
	Base_Resize(mBase.Width,mBase.Height)
	Invalidate
End Sub

Public Sub isGrid As Boolean
	Return isListGrid
End Sub

Public Sub Invalidate
	Filtered
	If isListGrid=False Then
		' Lst
		ScrollList.Panel.RemoveAllViews
		For I=0 To ListFilterItem.Size-1
			Visualize(I)
		Next
		ScrollList.PanelHeight=I*HeightImage
		ScrollList.Panel.Width=ScrollList.Width-40dip
		PositionY=-1
		InvalidateImage
	Else
		' Grid
		Dim im(ListFilterItem.Size) As B4XView
		Dim diff As Int = (HeightGridImage-HeightImage)/2
		
		ColsImages=(GridScroll.Width-20dip)/HeightGridImage
		Dim space As Int=(GridScroll.Width-ColsImages*HeightGridImage)/2
		TheImageView=im
		GridScroll.RemoveAllViews
		
		For i = 0 To ListFilterItem.Size-1
			VisualizeGrid(I,space,diff)
		Next
		Dim TotCol As Int = I/ColsImages
		GridScroll.PanelHeight=IIf(TotCol=I/ColsImages,TotCol,TotCol+1)*HeightGridImage
		GridScroll.PanelWidth=GridScroll.Width-10dip
	End If

End Sub

' Add Item - with Image
Public Sub AddItem (ID As String, Image As B4XBitmap, Name As String, Description As String, Info As String)
	Dim T As Gritem_Type
	T.Initialize
	T.ID=ID
	T.it=0
	T.Image=Image.Resize(HeightImage,HeightImage,True)
	T.Name=Name
	T.Description=Description
	T.Info=Info
	
	ListOfItem.Add(T)
	InvalidatLastElement
End Sub

' Add Item - with local file image 
Public Sub AddItemAsync (ID As String, FileName As String, Name As String, Description As String, Info As String)
	Dim T As Gritem_Type
	T.Initialize
	T.ID=ID
	T.it=1
	T.FileImage=FileName
	T.Name=Name
	T.Description=Description
	T.Info=Info
	
	ListOfItem.Add(T)
	InvalidatLastElement
End Sub

' Add Item - with local file image 
'Public Sub AddItemAsyncUrl (ID As String, UrlImage As String, Name As String, Description As String, Info As String)
'	Dim T As Gritem_Type
'	T.Initialize
'	T.ID=ID
'	T.it=2
'	T.FileImage=UrlImage
'	T.Name=Name
'	T.Description=Description
'	T.Info=Info
'	
'	ListOfItem.Add(T)
'	InvalidatLastElement
'End Sub

' Add Item - Without image - The image can be set later asynchronously
Public Sub AddItemNoImage (ID As String, Name As String, Description As String, Info As String)
	Dim T As Gritem_Type
	T.Initialize
	T.ID=ID
	T.it=3
	T.Name=Name
	T.Description=Description
	T.Info=Info
	
	ListOfItem.Add(T)
	InvalidatLastElement
End Sub

Public Sub SetImage(ID As String, Image As B4XBitmap)
	For I=0 To ListOfItem.Size-1
		Dim T As Gritem_Type = ListOfItem.Get(I)
		If T.ID=ID Then
			T.Image=Image
			T.it=0
			
			Invalidate
		End If
	Next
End Sub

Public Sub SetItem (ID As String, NewName As String, NewDescription As String, NewInfo As String)
	For I=0 To ListOfItem.Size-1
		Dim T As Gritem_Type = ListOfItem.Get(I)
		If T.ID=ID Then
			T.Name=NewName
			T.Description=NewDescription
			T.Info=NewInfo
			T.it=0
			
			Invalidate
		End If
	Next
End Sub

Public Sub size As Int
	Return ListOfItem.Size
End Sub

Public Sub Getid(position As Int) As String
	If position>=0 And position<ListFilterItem.Size Then
		Dim T As Gritem_Type = ListOfItem.Get(position)
		Return T.ID
	Else
		Return ""
	End If
End Sub

Public Sub GetName(ID As String) As String
	For I=0 To ListOfItem.Size-1
		Dim T As Gritem_Type = ListOfItem.Get(I)
		If T.ID=ID Then
			T.it=0
			Return T.name
		End If
	Next
	Return ""
End Sub

Public Sub GetDescription(ID As String) As String
	For I=0 To ListOfItem.Size-1
		Dim T As Gritem_Type = ListOfItem.Get(I)
		If T.ID=ID Then
			T.it=0
			Return T.Description
		End If
	Next
	Return ""
End Sub

Public Sub GetInfo(ID As String) As String
	For I=0 To ListOfItem.Size-1
		Dim T As Gritem_Type = ListOfItem.Get(I)
		If T.ID=ID Then
			T.it=0
			Return T.info
		End If
	Next
	Return ""
End Sub

Public Sub setButtonAddVisible(B As Boolean)
	ButtonAdd.Visible=B
End Sub

Public Sub setButtonExitVisible(B As Boolean)
	ButtonExit.Visible=B
End Sub

Public Sub setButtonsGridListVisible(B As Boolean)
	ButtonGrid.Visible=B
	ButtonList.Visible=b
End Sub

Public Sub setFilterVisible(B As Boolean)
	FilterLabel.Visible=B
	FilterText.Visible=B
	If Not(B) Then 
		FilterText.Text=""
		Filtered
	End If
End Sub

Public Sub setFilterHint(T As String)
	FilterLabel.Text=t
End Sub

Public Sub getFilterHint As String
	Return FilterLabel.Text
End Sub

Public Sub setFilterFont(F As B4XFont)
	FilterLabel.Font=F
End Sub

Public Sub getFilterFont As B4XFont
	Return FilterLabel.Font
End Sub

Public Sub setFilterSearchText(T As String)
	FilterText.Text=T
	#IF B4A
	Sleep(0)
	#end if
	ScrollList.PositionY=0
	Invalidate
	InvalidateImage
End Sub

Public Sub getFilterSearchText As String
	Return FilterText.text
End Sub

Public Sub ClearAll
	Do While AnimationActive
		Sleep(300)
	Loop
	ListOfItem.Initialize
	ListFilterItem.Initialize
	Invalidate
End Sub

#End Region

#Region Event

#If B4A or B4i

Private Sub ItemSelect_Click
	Dim P As B4XView = Sender
	Dim Index As Int = P.Tag
	Dim T As Gritem_Type = ListFilterItem.Get(Index)
	
	If xui.SubExists(mCallBack, mEventName & "_Clicked",2) Then
		CallSub3(mCallBack, mEventName & "_Clicked",Index,T.ID)
	End If
End Sub

#Else IF B4J

Private Sub ItemSelect_MouseClicked (EventData As MouseEvent)
	If EventData.PrimaryButtonPressed Then
		Dim P As B4XView = Sender
		Dim Index As Int = P.Tag
		Dim T As Gritem_Type = ListFilterItem.Get(Index)
	
		If xui.SubExists(mCallBack, mEventName & "_Clicked",2) Then
			CallSub3(mCallBack, mEventName & "_Clicked",Index,T.ID)
		End If
	End If
End Sub

#End if

Private Sub ButtonEvent_Click
	Dim B As Button = Sender
	Dim I As Int = B.Tag
	
	Select I
		Case 0 ' List
			isListGrid=True
			Base_Resize(mBase.Width,mBase.Height)
			Invalidate
		Case 1 ' Grid
			ListInMovement=False
			Sleep(300)
			isListGrid=False
			Base_Resize(mBase.Width,mBase.Height)
			Invalidate
		Case 2 ' Add
			If xui.SubExists(mCallBack, mEventName & "_Add",0) Then
				CallSub(mCallBack, mEventName & "_Add")
			End If
		Case 3 ' chiudi
			mBase.SetVisibleAnimated(300,False)
	End Select
End Sub

Private Sub FilterText_TextChanged (Old As String, New As String)
	#IF B4A
	Sleep(0)
	#end if
	ScrollList.PositionY=0
	Invalidate
	InvalidateImage
End Sub

Private Sub ScrollList_ScrollChangedY (Y As Double)
	AnimationActive=True
	Log(Y)
	ScrollFunction(Y)
End Sub

Private Sub ScrollFunction(y As Double)
	yy=y
	ListInMovement=True
	ObscurateImage
	#IF B4J 
	Sleep(300)
	#ELSE 
	Sleep(200)
	#End If
	If ScrollList.Positiony=Y Then
		' fermato
		Dim Height As Int = ScrollList.Panel.Height-ScrollList.Height
		Dim p As Int = Round((Y * Height) / HeightImage)*HeightImage
		Dim yf As Double = p/Height
		ScrollList.PositionY=Y+(yf-y)/3
		Sleep(40)
		ScrollList.PositionY=Y+(yf-y)*(2/3)
		Sleep(40)
		ScrollList.PositionY=yf
		InvalidateImage
		ListInMovement=False
	End If
	
	 If yy=y Then AnimationActive=False	 	
End Sub

#End Region

#Region Method Base

Public Sub GetBase As B4XView
	Return mBase
End Sub

Public Sub RequestFocus
	mBase.RequestFocus
End Sub

Public Sub SendToBack
	mBase.SendToBack
End Sub

Public Sub BringToFront
	mBase.BringToFront
End Sub

Public Sub setEnable(B As Boolean)
	mBase.Enabled=B
End Sub

Public Sub getEnable As Boolean
	Return mBase.Enabled
End Sub

Public Sub getLeft As Int
	Return mBase.Left
End Sub

Public Sub getTop As Int
	Return mBase.Width
End Sub

Public Sub getWidth As Int
	Return mBase.Width
End Sub

Public Sub getHeight As Int
	Return mBase.Width
End Sub

Public Sub setLeft(B As Int)
	mBase.Left=B
End Sub

Public Sub setTop(B As Int)
	mBase.Top=B
End Sub

Public Sub setHeight(B As Int)
	mBase.Height=B
End Sub

Public Sub setWidth(B As Int)
	mBase.Width=B
End Sub

Public Sub getVisible As Boolean
	Return mBase.Visible
End Sub

Public Sub setVisible(B As Boolean)
	mBase.Visible=B
End Sub

Public Sub SetVisibleAnimated(Duration As Int , Visible As Boolean)
	mBase.SetVisibleAnimated(Duration,Visible)
End Sub

Public Sub Snapshot As B4XView
	Return mBase.Snapshot
End Sub

#End Region

#Region Function

Private Sub Filtered
	If FilterText.IsInitialized Then
		Dim Fl As String = FilterText.Text.ToLowerCase.Trim
	
		If Fl="" Then
			ListFilterItem.Clear
			For i= 0 To ListOfItem.Size-1
				Dim T As Gritem_Type = ListOfItem.Get(i)
				ListFilterItem.Add(T)
			Next
		Else
			ListFilterItem.Clear
			For i= 0 To ListOfItem.Size-1
				Dim T As Gritem_Type = ListOfItem.Get(i)
				If (T.Name.ToLowerCase.IndexOf(Fl)>-1) Or (T.Description.ToLowerCase.IndexOf(Fl)>-1) Or (T.Codice.ToLowerCase.IndexOf(Fl)>-1) Then
					ListFilterItem.Add(T)
				End If
			Next
		End If
	End If
End Sub

Private Sub InvalidatLastElement
	If isListGrid= False Then
		Dim NumVis As Int = ListFilterItem.Size
		Filtered
		
		If NumVis+1=ListFilterItem.Size Then
			' Add new element
			Visualize(NumVis)
			If ListFilterItem.Size<=nImage Then InvalidateImage
		else if NumVis<>ListFilterItem.Size Then
			Invalidate
		End If
	Else
		Invalidate
	End If
End Sub

Private Sub Visualize(Pos As Int)
	Dim T As Gritem_Type = ListFilterItem.Get(Pos)
	Dim P As B4XView = xui.CreatePanel("ItemSelect")
	Dim textSize As Int = 16

	P.Tag=Pos
	ScrollList.AddView(P,0,Pos*HeightImage,ScrollList.Width-10dip,HeightImage)

	P.AddView(CreateLabel(T.Name,0xFF47518F,textSize),0,0,P.Width,P.Height/3)
	P.AddView(CreateLabel(T.Description,0xFF47518F,textSize),0,P.Height/3,P.Width,P.Height/3)
	P.AddView(CreateLabel(T.Info,0xFF47518F,textSize),0,P.Height*(2/3),P.Width,P.Height/3)
	P.AddView(createLinea(0xFF47518F),0,P.Height-2dip,P.Width,2dip)

	ScrollList.PanelHeight=Pos*HeightImage
	ScrollList.PanelWidth=ScrollList.width-10dip
End Sub

Private Sub VisualizeGrid(Pos As Int, Space As Int, Diff As Int)
	Dim T As Gritem_Type = ListFilterItem.Get(Pos)
	Dim P As B4XView = xui.CreatePanel("ItemSelect")
	Dim textSize As Int = 16

	Dim X As Int=(Pos Mod ColsImages)*HeightGridImage
	Dim Y As Int=Floor(Pos/ColsImages)*HeightGridImage

	
	TheImageView(Pos)=ImageView("")
	TheImageView(Pos).Color=xui.Color_Transparent
	P.Tag=Pos
	P.SetColorAndBorder(xui.Color_ARGB(50,150,150,150),0dip,xui.Color_Transparent,15dip)
	
	GridScroll.AddView(P,Space+x,y,HeightGridImage-1dip,HeightGridImage-1dip)
	
	
	p.AddView(TheImageView(Pos),Diff,0,HeightImage,HeightImage)
	
	p.AddView(CreateLabel(T.Name,0xFF47518F,textSize),5dip,HeightImage,HeightGridImage-10dip,35dip)
	'p.AddView(CreateLabel(T.Description,0xFF47518F,textSize),5dip,HeightImage+35dip,HeightGridImage-10dip,35dip)
	'p.AddView(CreateLabel(T.Info,0xFF47518F,textSize),5dip,HeightImage+70dip,HeightGridImage-10dip,30dip)
	
	TheImageView(Pos).SetBitmap(RequestBitmap(Pos).Resize(HeightImage,HeightImage,False))
End Sub

Private Sub InvalidateImage
	If isListGrid=False Then
		PositionY=ScrollList.PositionY
		Dim Height As Int = ScrollList.Panel.Height-ScrollList.Height
		Dim P As Int = (PositionY * Height)/HeightImage

		For I=1 To nImage
			Dim pos As Int = P+I-1
		
			If pos<ListFilterItem.Size Then
				Dim T As Gritem_Type = ListFilterItem.Get(pos)
				Select T.it
					Case 0 ' Bitmap
						TheImageView(i-1).SetBitmap(CreateRoundRectBitmap(T.Image.Resize(HeightImage-20dip,HeightImage-20dip,False),20dip))
						TheImageView(i-1).Tag=T.Image
					Case 1 ' file
						TheImageView(i-1).SetBitmap(CreateRoundRectBitmap(xui.LoadBitmap("",T.FileImage).Resize(HeightImage-20dip,HeightImage-20dip,False),20dip))
						TheImageView(i-1).Tag=xui.LoadBitmap("",T.FileImage)
					Case 2 ' url
					
					Case 3 ' nothing
						TheImageView(i-1).SetBitmap(xui.LoadBitmapResize(File.DirAssets,"empty.png",HeightImage-20dip,HeightImage-20dip,False))
						TheImageView(i-1).Tag=xui.LoadBitmap(File.DirAssets,"empty.png")
				End Select
			Else
				' no-image
				TheImageView(i-1).SetBitmap(xui.LoadBitmapResize(File.DirAssets,"empty.png",HeightImage-20dip,HeightImage-20dip,False))
			End If
		Next
	Else
		' GRID
	End If
End Sub

Private Sub RequestBitmap(Pos As Int) As B4XBitmap
	Dim T As Gritem_Type = ListFilterItem.Get(Pos)
	Select T.it
		Case 0 ' Bitmap
			Return CreateRoundRectBitmap(T.Image.Resize(HeightImage-20dip,HeightImage-20dip,False),20dip)
		Case 1 ' file
			Return CreateRoundRectBitmap(xui.LoadBitmapResize("",T.FileImage,HeightImage-20dip,HeightImage-20dip,False),20dip)
		Case 2 ' url
			
		Case 3 ' nothing
			Return CreateRoundRectBitmap(xui.LoadBitmapresize(File.DirAssets,"empty.png",HeightImage-20dip,HeightImage-20dip,False),20dip)
	End Select
	
	Return CreateRoundRectBitmap(xui.LoadBitmapresize(File.DirAssets,"empty.png",HeightImage-20dip,HeightImage-20dip,False),20dip)
End Sub

Private Sub ObscurateImage
	'Dim Height As Int = ScrollList.Panel.Height-ScrollList.Height
	'Dim P As Int = (PositionY * Height)/HeightImage
	If ListInMovement=False Then
		If PanelList.NumberOfViews>nImage Then
			For I=1 To PanelList.NumberOfViews-nImage
				PanelList.GetView(0).RemoveViewFromParent
			Next
		End If
		
		For I=1 To nImage
			If isListGrid=False Then
				If Animated Then
					TheImageView(i-1).SetBitmap(CreateRoundRectBitmap(Blur(TheImageView(I-1).tag),(HeightImage-0dip)/2).Resize(HeightImage-20dip,HeightImage-20dip,False))
				Else
					TheImageView(i-1).SetBitmap(Blur(TheImageView(I-1).Tag).Resize(HeightImage-20dip,HeightImage-20dip,False))
				End If
			End If
		Next
	
		Sleep(0)
		If Animated Then
			Do While ListInMovement And isListGrid=False
				For I=1 To nImage
					TheImageView(i-1).SetRotationAnimated(150,180)
				Next
				Sleep(160)
				For I=1 To nImage
					TheImageView(i-1).SetRotationAnimated(0,0)
				Next
			Loop
		End If
	End If
End Sub

Sub CreateRoundRectBitmap (Input As B4XBitmap, Radius As Float) As B4XBitmap
	Dim BorderColor As Int = xui.Color_Black
	Dim BorderWidth As Int = 1dip
	Dim c As B4XCanvas
	Dim xview As B4XView = xui.CreatePanel("")
	xview.SetLayoutAnimated(0, 0, 0, Input.Width, Input.Height)
	c.Initialize(xview)
	Dim path As B4XPath
	path.InitializeRoundedRect(c.TargetRect, Radius)
	c.ClipPath(path)
	c.DrawRect(c.TargetRect, BorderColor, True, BorderWidth) 'border
	c.RemoveClip
	Dim r As B4XRect
	r.Initialize(BorderWidth, BorderWidth, c.TargetRect.Width - BorderWidth, c.TargetRect.Height - BorderWidth)
	path.InitializeRoundedRect(r, Radius - 0.7 * BorderWidth)
	c.ClipPath(path)
	c.DrawBitmap(Input, r)
	c.RemoveClip
	c.Invalidate
	Dim res As B4XBitmap = c.CreateBitmap
	c.Release
	Return res
End Sub

Public Sub GrayBitmap(bmp As B4XBitmap) As B4XBitmap
	Dim ColorBC, GreyBC As BitmapCreator
	
	ColorBC.Initialize(bmp.Width / bmp.Scale, bmp.Height / bmp.Scale)
	ColorBC.CopyPixelsFromBitmap(bmp)
	GreyBC.Initialize(ColorBC.mWidth, ColorBC.mHeight)
	'greyscale
	Dim argb As ARGBColor
	For x = 0 To ColorBC.mWidth - 1
		For y = 0 To ColorBC.mHeight - 1
			ColorBC.GetARGB(x, y, argb)
			Dim c As Int = argb.r * 0.21 + argb.g * 0.72 + 0.07 * argb.b
			argb.r = c
			argb.g = c
			argb.b = c
			GreyBC.SetARGB(x, y, argb)
		Next
	Next
	Return GreyBC.Bitmap
End Sub

Private Sub Blur (bmp As B4XBitmap) As B4XBitmap
	Dim bc As BitmapCreator
	Dim ReduceScale As Int = 2
	bc.Initialize(bmp.Width / ReduceScale / bmp.Scale, bmp.Height / ReduceScale / bmp.Scale)
	bc.CopyPixelsFromBitmap(bmp)
	Dim count As Int = 3
	Dim clrs(3) As ARGBColor
	Dim temp As ARGBColor
	Dim m As Int
	For steps = 1 To count
		For y = 0 To bc.mHeight - 1
			For x = 0 To 2
				bc.GetARGB(x, y, clrs(x))
			Next
			SetAvg(bc, 1, y, clrs, temp)
			m = 0
			For x = 2 To bc.mWidth - 2
				bc.GetARGB(x + 1, y, clrs(m))
				m = (m + 1) Mod clrs.Length
				SetAvg(bc, x, y, clrs, temp)
			Next
		Next
		For x = 0 To bc.mWidth - 1
			For y = 0 To 2
				bc.GetARGB(x, y, clrs(y))
			Next
			SetAvg(bc, x, 1, clrs, temp)
			m = 0
			For y = 2 To bc.mHeight - 2
				bc.GetARGB(x, y + 1, clrs(m))
				m = (m + 1) Mod clrs.Length
				SetAvg(bc, x, y, clrs, temp)
			Next
		Next
	Next
	Return bc.Bitmap
End Sub

Private Sub SetAvg(bc As BitmapCreator, x As Int, y As Int, clrs() As ARGBColor, temp As ARGBColor)
	temp.Initialize
	For Each c As ARGBColor In clrs
		temp.r = temp.r + c.r
		temp.g = temp.g + c.g
		temp.b = temp.b + c.b
	Next
	temp.a = 255
	temp.r = temp.r / clrs.Length
	temp.g = temp.g / clrs.Length
	temp.b = temp.b / clrs.Length
	bc.SetARGB(x, y, temp)
End Sub

Private Sub ChangeButtonTextColor(B As B4XView, Col As Int)
	#if B4J or B4A
	B.TextColor=Col
	#Else IF B4i
	Dim B2 As Button = B
	Dim no As NativeObject = B2
	Dim state As Int = 0
	no.RunMethod("setTitleColor:forState:", Array(no.ColorToUIColor(Col), state))
	#End If
End Sub

#End Region

#Region Create View

Private Sub CreateButton(EventaNAme As String) As B4XView
	Dim B As Button
	
#If B4i
	B.Initialize(EventaNAme,B.STYLE_SYSTEM)
#ELSE IF B4J
	B.Initialize(EventaNAme)
#ELSE IF B4A
	B.Initialize(EventaNAme)
#End If
	Return B
End Sub

Private Sub CreateTextView(EventaName As String) As B4XView
#If B4i
	Dim T As TextField
	T.Initialize(EventaName)
#ELSE IF B4J
	Dim T As TextField
	T.Initialize(EventaName)
#ELSE IF B4A
	Dim T As EditText
	T.Initialize(EventaName)
	T.SingleLine=True
#End If
	T.As(B4XView).TextSize=14
	Return T
End Sub

Private Sub createLinea(ColorLinea As Int) As B4XView
	Dim L As B4XView = xui.CreatePanel("")
	L.Color=ColorLinea
	Return L
End Sub

Private Sub CreateLabel(Text As String,TextColor As Int, TextSize As Int) As B4XView
	Dim L As Label
	L.Initialize("")
	#IF B4I
	L.Multiline=True
	#ELSE IF B4A
	L.SingleLine=False
	#ELSE IF B4j
	L.WrapText=True
	#END IF
	Dim Lx As B4XView = L
	Lx.Text=Text
	Lx.TextColor=TextColor
	Lx.TextSize=TextSize
	Lx.SetTextAlignment("CENTER","LEFT")
	Lx.Color=xui.Color_Transparent
	
	Return Lx
End Sub

Public Sub ImageView(EventName As String) As B4XView
	Dim Im As ImageView

	Im.Initialize(EventName)

	Return Im
End Sub

#End Region